;;;
;;; resource-types.lisp
;;;
;;; Resource type hierarchy
;;;
;;; Copyright (C) 2005, Alastair Bridgewater
;;;

(in-package :clxs)

(defclass resource () ())
(defclass drawable-resource (resource) ())
(defclass window-resource (drawable-resource) ())
(defclass pixmap-resource (drawable-resource) ())
(defclass cursor-resource (resource) ())
(defclass fontable-resource (resource) ())
(defclass font-resource (resource) ())
(defclass gcontext-resource (resource) ())
(defclass colormap-resource (resource) ())

;;; EOF
